##############################################################
# class StructuredPushSupplier
##############################################################
class StructuredPushSupplier
{
 # Constructor
 proc __StructuredPushSupplier__(self,name)
 {
   self.name = name;
   CORBA.ORB.connect(self,CosNotifyComm.StructuredPushConsumer); 
 }

 #Implementation CosNotify::NotifySubscribe
 proc subscription_change(self,added,removed)
 {
    println("PushSupplier(", self.name,") offer change: ");
    println("  added:",added);
    println("  removed:",removed);
 }

 proc disconnect_sequence_push_consumer(self)
 {
    println("PushConsumer(", self.name, ") disconnect_push_supplier")
 }

 # Interface zum Programm
 proc connect(self,ncior)
 {
   idH = Holder();
   self.sa = ncior.new_for_suppliers(CosNotifyChannelAdmin.InterFilterGroupOperator.AND_OP,idH);
   proxyidH = Holder();
   self.proxy = self.sa.obtain_notification_push_consumer(CosNotifyChannelAdmin.ClientType.STRUCTURED_EVENT,proxyidH);
   self.proxy.connect_structured_push_supplier(self);
   println("PushSupplier(", self.name, ") is connected to the NotifyChannel.")
 }

 proc offer(self,added)
 {
   remove=CosNotification.EventTypeSeq();
   self.proxy.offer_change(added,remove);
 }

 proc disconnect(self)
 {
   self.proxy.disconnect_structured_push_consumer();
   println("PushSupplier(", self.name, ") is disconnected to the NotifyChannel.")
 }

 proc push(self,event)
 {
   self.proxy.push_structured_event(event);
 }
}
